
Object sc_4
  class Scene,
  with
	number 4,
	init_scene [;
		SetQuestion(q4_1);
	],
	begin_scene [ rock;
		bigguards.startup();
		give LabJunction ~general;
		switch (rock) {
			1: ! first time in
				move activeplayer to OutsideLab; 
				SaveToolPositions();
			2, -1, -2: ! all subsequent times (including boom/splat)
				move activeplayer to OutsideLab; 
				RestoreToolPositions();
				give labdoorstruts ~general;
		}
	],
	end_scene [ rock subrock;
		bigguards.shutdown();
		switch (rock) {
			-1:
				SetAcidQuestions(subrock);
			-2:
				SetBlastQuestions(subrock);
			-3: ! security door open
				" ,   . --! []";
			1:
				if (q4_d1 hasnt general) {
					give q4_d1 general;
					SetQuestion(q4_d1);
				}
				else if (q4_d1r hasnt general) {
					give q4_d1r general;
					SetQuestion(q4_d1r);
				}
				else {
					SetQuestion(q4_d1rr);
				}
			2: ! left tools behind
				SetQuestion(q4_d2, subrock);
			20: ! success
				SetScene(sc_5);
		}
	];


! Emotional status to date: (absolute strained maximums)
! Minimum: 6 helpful, 2 cosmos, nothing else.
! Maximum: 3 blatant lies, 4 sneaky lies, 8 stubborns, 5 angries, 2 stupid,
!   2 jingos.
! (That's not counting acid/blast queries, which are 1 sneaky, 3 blatant,
! 3 stubborn, 1 angry; or 1 helpful.)
! During startup: +1 helpfuls, +2 cosmos; or else +1 blatant, +3 jingos;
!   or else +1 blatant, +2 stupids.

Object q4_1
  class Question,
  with
	query "^@<< .    ,      .      ,      .     ,   @>>.",
	time_limit 5,
	daemon [;
		if (self.number == 4) {
			print "^@<<   ,    - @>>.^";
		}
	],
	answer_yes [;
		num_helpfuls++;
		print "@<<,  ,     ?@>>^";
		SetQuestion(q4_21);
	],
	answer_no [;
		num_blatant_lies++;
		print "@<<  -- , -- ";
		if (num_sneaky_lies >= 3)
			print "  .";
		else
			print " ,  .";
		print " -- @<< ,     ,    --   . , ,  @>>.   ,      . @<<  ", (emphstring) ".", "    ?@>>^";
		SetQuestion(q4_22);
	],
	answer_wait [;
		num_stubborns++;
		print "    ,  ,     . @<< ,     ,      @>>.^";
		SetQuestion(q4_21);
	];
	
Object q4_21
  class Question,
  with
	query [; rtrue; ],
	time_limit 3,
	answer_yes [;
		print "@<<   .";
		SetQuestion(q4_3);
	],
	answer_no [;
		print "@<< .     .";
		SetQuestion(q4_3);
	],
	answer_wait [;
		print "@<<, .     .";
		SetQuestion(q4_3);
	];

Object q4_22
  class Question,
  with
	query [; rtrue; ],
	time_limit 1,
	answer_yes [;
		num_cosmos++;
		print "@<< ,   .       --  ,     - .  , ,  @>>.^^ - ,       . @<<  .";
		SetQuestion(q4_3);
	],
	answer_no [;
		print "@<< ,   .       --  ,     - .  , ,  @>>.^^ - ,       . @<<  .";
		SetQuestion(q4_3);
	],
	answer_wait [;
		print "  : @<< ,   .       --  ,     - .  , ,  @>>.^^ - ,       . @<<  .";
		SetQuestion(q4_3);
	];

Object q4_3
  class Question,
  with
	query [;
		print "     - ", (emphstring) "?", "  ,      ?@>>         ,  .^";
		rtrue;
	],
	time_limit 3,
	number2 0,
	answer_yes [;
		num_jingos++;
		self.number2 = 'yes';
		print "@<< ", (emphstring) ",", "       .";
		SetQuestion(q4_4);
	],
	answer_no [;
		num_stupids++;
		self.number2 = 'no';
		print "@<<   .  ,   @>>. , , . @<<   - .";
		SetQuestion(q4_4);
	],
	answer_wait [;
		num_stupids++;
		self.number2 = 'wait';
		print "@<<, ", (emphstring) "", "  .    ...";
		SetQuestion(q4_4);
	];

Object q4_4
  class Question,
  with
	query [;
		print " ~ ~.  ,       .         ,       .     --     . , --   , -- .     @>>.   - ,          .^^@<<  ,     .    ,    . ,  .   ,   .        ,       ,  ...?@>>^";
		rtrue;
	],
	time_limit 2,
	answer_yes [;
		num_jingos++;
		if (q4_3.number2 == 'yes')
			print "@<<  ,  .     --@>>  . @<<";
		else
			print "@<<,    . ";
		SetQuestion(q4_5);
	],
	answer_no [;
		num_stupids++;
		if (q4_3.number2 == 'no')
			print "@<<, .   .  ... ";
		else
			print "@<< !   !  ,   ... ";
		SetQuestion(q4_5);
	],
	answer_wait [;
		if (q4_3.number2 == 'wait')
			print "@<< ", (emphstring) ".", " ";
		else
			print "     ,   . @<<";
		SetQuestion(q4_5);
	];

Object q4_5
  class Question,
  with
	query [;
		print ",     .    ", 
			(emphstring) "", " ?  , .        . - -  ,     @>>.      . @<<     ", 
			(emphstring) "", "   .       .      ,   ,  .     .    ,   ,     ,       ,     ? ? ? ?@>>^";
		rtrue;
	],
	time_limit 6,
	answer_yes [;
		num_jingos++;
		print "  ,     - . @<<   ,      . . @>>.^";
		BeginScene(1);
	],
	answer_no [;
		num_cosmos++;
		print "     ...   . @<<      ,   --  .  . @>>.^";
		BeginScene(1);
	],
	answer_wait [;
		num_helpfuls++;
		print "@<<,   .  @>>.    . @<<. @>>.^";
		BeginScene(1);
	];

Object q4_d1
  class Question,
  with
	query [;
		if (num_got_angry <= 1 && num_stubborns <= 3) { 
			self.variant = 1;
			print "^    . @<< ,     ?  ,           @>>.^";
			rtrue;
		}
		else if (num_got_angry <= 2 && num_stubborns > 3) {
			self.variant = 2;
			print "^ . @<<.  .  ";
			if (num_blatant_lies + num_sneaky_lies <= num_helpfuls)
				print " ";
			else
				print " ";
			print "     @>>.^";
			BeginScene(2);
			rtrue;
		}
		else if (num_got_angry <= 3 || num_stubborns > 5) {
			self.variant = 3;
			print "^@<<   ,  .  ,    ";
			if (num_blatant_lies > 1) {
				print ",        ";
			}
			else {
				print ",   ,        ";
			}
			".    ,  .      ?@>>";
		}
		else { ! num_got_angry > 3
			self.variant = 3;
			"^@<<!      .     ,    ,     ,  ?@>>";
		}
	],
	time_limit 2,
	answer_yes [;
		switch (self.variant) {
			1: 
				num_cosmos++;
				print "@<<     @>>.^";
			3:
				print "@<< ,  @>>.^";
		}
		BeginScene(2);
	],
	answer_no [;
		switch (self.variant) {
			1: 
				num_jingos++;
				print "     ,      ,        . @<< .        .   ,    @>>.^";
			3:
				num_got_angry++;
				print "   . @<<      @>>.      .^";
				BrainDrain();
				rtrue;
		}
		BeginScene(2);
	],
	answer_wait [;
		switch (self.variant) {
			1: 
				num_cosmos++;
				print "  . @<<,   ,    .       @>>.  . @<< ,     ,       . ,     ,   .  -    --  ,    ,  --      @>>.^";
			3:
				num_got_angry++;
				print "  . @<<        .    @>>.^";
		}
		BeginScene(2);
	],
  has ~general; ! general means it's been asked

Object q4_d1r
  class Question,
  with
	query [;
		if (num_stupids <= 2) {
			print "^@<<     ,    .    ,    @>>.^";
		}
		else {
			print "^@<< ", (emphstring) "", "   ?       . !    @>>.^";
		}
		BeginScene(2);
	],
  has ~general; ! general means it's been asked

Object q4_d1rr
  class Question,
  with
	query [;
		print "^@<<,  ";
		self.number2++;
		switch (self.number2) {
			1: print ".  ,     ";
			2: print ".      ";
			4: print ". ";
			5: self.number2 = 0;
		}
		print "@>>.^";
		BeginScene(2);
	],
	number2 0;

Object q4_d2
  class Question,
  with
	query [;
		print "^@<<,  ,     .";
		if (self.variant == 1)
			print "    ";
		else
			print "     ", (cGen) self.variant, ",   ";
		! print " left behind";
		print ".  ,       @>>.^";
		BeginScene(2);
	];

Object q4_db1
  class Question,
  with
	query "^@<<,  ,  .   ,  ,      @>>.   . @<< ,  ,     ,   .   ,          .         ?    ?@>>   .",
	time_limit 4,
	answer_general [;
		print "      ,      .        @>>.    .";
		if (num_stupids >= 2) {
			print " @<<   .  ,      ,       .   ,  , ... @>>.^";
		}
		else if (num_cosmos >= 2) {
			print " @<< ,  ;  ,  .       ", (emphstring) "", " ,    . ,   @>>.^";
		}
		else {
			print " @<<, , .  .   ,    @>>.^";
		}
	],
	answer_yes [;
		num_dumb_recall++;
		print "@<<", (emphstring) "?";
		self.answer_general();
		BeginScene(2);
	],
	answer_no [;
		print "@<<     ? --  . --  ,      .       ?           ,  ,      @>>.^";
		SetQuestion(q4_db11);
	],
	answer_wait [;
		num_dumb_recall++;
		print "@<<,   ...";
		self.answer_general();
		BeginScene(2);
	],
  has ~general; ! general means it's been asked

Object q4_db11
  class Question,
  with
	query [; rtrue; ],
	time_limit 2,
	answer_yes [;
		print "@<<... --    , --    ,   ... ,         --@>>.    ,   . @<<--@>>.^";
		BrainDrain();
	],
	answer_no [;
		print "  . @<< ,  -     -   .    -  ,     @>>.^";
		BeginScene(2);
	],
	answer_wait [;
		print "@<<  ", (emphstring) "", " ?@>>	  . @<< ,  -     -   .    -  ,     @>>.^";
		BeginScene(2);
	];
	
Object q4_db1r
  class Question,
  with
	query [; 
		print "^@<<  ,  ,    .       @>>.^";
		BeginScene(2);
	];

Object q4_da1
  class Question,
  with
	query [;
		print "^@<< .          --        ...  @>>.     ,       . @<<         ";
		if (SeenDoorsPitted)
			print ",    ";
		print ".   ,  ,   @>>.^";
		BeginScene(2);
	],
  has ~general; ! general means it's been asked

Object q4_da1r
  class Question,
  with
	query [;
		num_stubborns++;
		print "^@<<         ,   .";
		if (qn_a1 has general) {
			print "   :       ,      .";
		}
		else {
			print "  -    --   ,        - .";
		}
		print "@>>^";
		BeginScene(2);
	],
  has ~general; ! general means it's been asked

Object q4_da1rr
  class Question,
  with
	query [;
		print "^@<<    ?@>>^";
		BeginScene(2);
	];
	
! ------------- The scene at the lab door

Object OutsideLab " "
  with
	description [;
		print ",   ,  ,      .     ,    ,   - ... . .      ,     -  .^";
		if (child(labdoorstruts)) {
			new_line;
			<Search labdoorstruts>;
		}
		if (labdoor has open) {
			print "^  ";
			if (labdoorguards.number2 == 1)
				print "    .^";
			else
				print " .^";
		}
		if (powercut) {
			print "^  -  .^";
		}
		rtrue;
	],
	se_to [; <<Go e_obj>>; ],
	e_to [;
		print "      -.^";
		return LabJunction;
	],
	w_to labdoor,
	cant_go "   -,   --  .";

Object -> labdoor "/  "
  with
	name '//' '' '' '' '' ''  '' '' '',
	description [;
		print "    ,    ,   - ... . .      ,     -  .       .^";
		if (child(labdoorstruts)) {
			new_line;
			<Search labdoorstruts>;
		}
		rtrue;
	],
	door_to Laboratory, 
	door_dir w_to,
	door_try [;
		if (self has open) {
			if (labdoorguards.number2 == 1)
				print "    ,      .^";
			rfalse;
		}
		PronounNotice(self);
		print_ret (CCNom) self, "   ."; 
	],
	before [;
		Open: 
			if (self has open)
				"  .";
			"    .";
		Close:
			if (self hasnt open)
				"  .";
		Push, Turn: 
			" .";
		Touch, Rub: 
			<<Touch labdoorcoating>>;
		Receive:
			<<Insert noun labdoorstruts>>;
		TouchFrom:
			if (noun == lockpick)
				rfalse;
			<<Insert noun labdoorstruts>>;
		ActivateTool:
			if (~~escaping)
				"^ ,     ,  . []";
			if (self has open) {
				"^-  ,    .";
			}
			give self open;
			labdoorguards.number2 = 2;
			print "^-   ", (emphstring) "", ".       ,  -    .^";
			rtrue;
	],
  has scenery door ~open female;

Object -> labdoorplate "/ /  "
  class InteriorPlate,
  with
	work_target labdoor,
	shortout [;
		give labdoor locked;
	];

Object -> labdoorstruts "/"
  with
	name '' '' '' '' '' '',
	description [;
		print "     ,      .      ,    .";
		if (child(self)) {
			print " ";
			<Search self>;
		}
		else {
			new_line;
		}
		rtrue;
	],
	before [;
		Search:
			if (child(self) == nothing) 
				"    .";
			print "   ";
            if (children(self) > 1)
                print "";
            else
                print "";
            print "c ";
			WriteListFrom(child(self),
				!ISARE_BIT + TERSE_BIT + ENGLISH_BIT + PARTINV_BIT);
				TERSE_BIT + ENGLISH_BIT + PARTINV_BIT);
			".";
		Receive:
			if (receive_action == ##PutOn)
				<<Insert noun self>>;
		Touch, Rub: 
			<<Touch labdoorcoating>>;
		Attack, Push, Pull, Turn:
			"   ,  ,    .";
		Climb:
			"      ,     .     .";
	],
	after [ ix;
		Receive:
			if (self hasnt general) {
				give self general;
				print_ret "   ", (cAcc) noun, "    . ", (Pronoun) noun, " ", (V1bEnd) noun, "   ,   .";
			}
			ix = child(self);
			if (ix == noun)
				ix = sibling(ix);
			print "  ", (cAcc) noun, "    ";
			if (ix == nothing)
				".";
			if (sibling(ix))
				",   ,    .";
			print_ret ",   ", (cIns) ix, ".";
	],
  has scenery open container pluralname; ! general means you've put stuff there.

Object -> labdoorcoating "/ /"
  with
	name '' '' '' '' '' '' '',
	description "       -   .   ,  .",
	before [;
		Touch, Rub:
			"׸      --  ,  ,     .";
		Push, Pull:
			"׸        .";
		Attack:
			"         .";
		Take:
			"׸   .";
	],
  has scenery neuter;

Object -> labdoorcorridor "/"
  with
	name '' '//' '' '',
	description "   ,     ,   -.",
	before [;
		Enter:
			<<Go e_obj>>;
		ThrownAt, Receive:
			verb_word = 'throw';
			<<ThrowDir noun e_obj>>;
	],
  has scenery male;
	
Object LabJunction "  "
  with
	description [;
		print "       ,   , ,   -   .";
		if (bigguards in self) {
			if (self hasnt general) {
				give self general;
				print "^^,  ,      --   ,   ,   . ,    .";
			}
			else {
				print "    - ,      .";
			}
		}
		new_line;
		if (powercut) {
			print "^      - .^";
		}
		rtrue;
	],
	nw_to [;
		print "       .^";
		if (escaping && powercut) {
			ReachLabDoor();
		}
		return OutsideLab;
	],
	e_to [;
		if (bigguards in self) {
			if (bigguards.number == 4 or 5 or 6 or 24) {
				print ",   . ,   ,   ,         .^";
				TryPassBigGuards();
				rtrue;
			}
			print "    .     .^";
			EndScene(1);
			rtrue;
		}
		! escaping
		return NortheastCorner;
	], 
	s_to [;
		if (bigguards in self) {
			print "        . ,   ,    ,    .^";
			EndScene(1);
			rtrue;
		}
		! escaping
		return SharpCorner;
	],
  has ~general; ! general means you walked in on the guards
 
Object bigguards "/"
  with
	name '' '' '' '' '' '' '//' '' '',
	description [;
		print "   - .    ,       -.    .";
		switch (self.number) {
			3, 23: "               .    -   ,        .";
			4, 24: "     ,  .";
			5: "  ,      ,  -  .   ,   .";
			25: "    ,    .";
			6, 7, 8:
				"    ,         - .       .";
			26:
				print "       .   ,    ,     .^";
				EndScene(1);
				rtrue;
			27: "  . []";
			9, 29: "   ,        -.       .";
			default:
				"      -,   ,        .";
		}
	],
	react_before [;
		Listen:
			if (noun == 0) {
				print "(  ", (cDat) self, ")^";
				<<Listen self>>;	
			}
		ThrowDir:
			if (second == s_obj)
				<<ThrowAt noun self>>;
			!### east, they don't notice. Or only three notice?
			!### except then we need an 'east' object.
		Hide:
			return L__M(##Hide, 2);
	],
	before [;
		Examine:
			rfalse;
		Listen:
			switch (self.number) {
				3, 23: "    . ,  ,    .";
				4, 24: " .";
				5: "    .";
				25: "     .";
				26: "        .";
				27: "    . []";
				default:
					"   .";
			}
		Enter:
			<<Go s_obj>>;
		ThrownAt:
			print (CCNom) noun, "   ", (V2bEnd) noun,  "     .      ,    .     ,     .^";
			EndScene(1);
			rtrue;
		Receive:
			<<ThrowAt noun self>>;
		default:
			"     .";
	],
	life [;
		<<Touch self>>;
	],
	number 0, ! used for daemon timer
	daemon [;
		if (self.number == 0 && location ~= parent(self)) {
			return; ! don't start the countdown until the player walks in
		}
		
		self.number++;
		if (location == parent(self)) {
			switch (self.number) {
				3: print "^      .^";
				4: print "^   , @<<, @>>.^";
				5: print "^     .  ,     .^";
				9: print "^ ,   , , ,    .^";
				23: print "^      .^";
				24: print "^   , @<<, @>>.^";
				25: print "^     ,     .^";
				26: print "^    .^";
				27: 
					print "^   - ,         -- ,   ,    .^";
					EndScene(1);
					rtrue;
				29: print "^ ,   , , ,    .^";
			}
		}
		
		switch (self.number) {
			7: 
				if (random(11) < 6)
					self.number++;
			11:
				self.number = 21;
			26:
				if (location == OutsideLab)
					self.number++; ! safety feature
			31:
				self.number = 1;
		}
	],
	startup [;
		move self to LabJunction;
		self.number = 0;
		StartDaemon(self);
	],
	shutdown [;
		StopDaemon(self);
		remove self;
	],
  has scenery animate pluralname; 

[ TryPassBigGuards   ix;

	ix = LeftToolsBehind(4);
	if (ix) {
		EndScene(2, ix);
		rtrue;
	}

	EndScene(20);
	rtrue;
];
