
#ifndef ZDEBUG;
Message error "You can't include tangle-alt.inc when debugging is off!";
#endif;

[ debug_dumpgrot;
	LeftToolsBehind();
	SaveToolPositions();
	RestoreToolPositions();
	SetAcidQuestions();
	SetBlastQuestions();
	debug_dumpgrot();
];

#ifdef SKIP_SCENE_1;

Object sc_1
  class Scene,
  with
	number 1;

Object q1_1
  class Question; ! squash "unused" warnings

Object EndOfAlley "End of Alley"
  with
	description "First room.",
	number BrainDrain SetQuestion, ! squash "unused" warnings
	s_to MouthOfAlley,
	e_to CantGoThatWay;

Object -> outerdoorplate "black plate by the door"
  with
	name 'small' 'black' 'rectangle' 'plate',
  has static;

Object MouthOfAlley "Mouth of Alley"
  with
	description "Second room.",
	n_to EndOfAlley;

#endif; ! SKIP_SCENE_1;

! ----------------------------------------

#ifdef SKIP_SCENE_2;

Object sc_2
  class Scene,
  with
	number 2,
	begin_scene [ rock;
		rock = 0;
		rock = GiveInitialTools; ! mention, not use
		move activeplayer to WhiteJunction;
	];

Object q2_d3
  class Question;

Object WhiteJunction "White Junction"
  with
	description "Second room.";

Constant InsideEntrance WhiteJunction;
Constant SouthBoundary WhiteJunction;
Constant NorthBoundary WhiteJunction;
Constant CeilingHole WhiteJunction;
Constant StorageCloset WhiteJunction;

Object panelhole;
Object panelcache;
Object blood;
Object outerdoorin;
Object boundaryweb;
Object boundaryline;

Object boltwrench "bolt wrench" WhiteJunction
  with name 'bolt' 'wrench';

Object package "wrapped package" WhiteJunction
  with
	name 'wrapped' 'package' 'bundle' 'cloth',
	data_cache 0,
	save_pos [ ptr;
		ptr = self.&data_cache;
		ptr-->0 = parent(self);
	],
	restore_pos [ ptr;
		ptr = self.&data_cache;
		set_parent(self, ptr-->0);
	];

#endif; ! SKIP_SCENE_2;

#ifdef SKIP_SCENE_3;

Object sc_3
  class Scene,
  with
	number 3,
	begin_scene [ rock;
		rock = 0;
		rock = nop; ! mention, not use
		move activeplayer to TossJunction;
	];

Object TossJunction "Toss Junction"
  with
	description "Third room.";

Constant DeadEndHall TossJunction;
Constant SouthFrontier TossJunction;

Object tossend;

#endif; ! SKIP_SCENE_3;

#ifdef SKIP_SCENE_4;

Object sc_4
  class Scene,
  with
	number 4,
	begin_scene [ rock;
		rock = 0;
		rock = nop; ! mention, not use
		move activeplayer to OutsideLab;
	];

Object OutsideLab "Outside Lab"
  with
	description "Fourth room.";

Constant LabJunction OutsideLab;

Object labdoorstruts;

Object q4_3
  class Question;

Constant q4_da1 q4_3;
Constant q4_da1r q4_3;
Constant q4_da1rr q4_3;
Constant q4_db1 q4_3;
Constant q4_db1r q4_3;

#endif; ! SKIP_SCENE_4;

#ifdef SKIP_SCENE_5;

Object sc_5
  class Scene,
  with
	number 5,
	begin_scene [ rock;
		rock = 0;
		rock = nop; ! mention, not use
		move activeplayer to SecurityAnnex;
	];

Object SecurityAnnex "Security Annex"
  with
	description "Fifth room.";

Constant SecurityBranch SecurityAnnex;
Constant SecurityOffice SecurityAnnex;
Constant SecurityStorage SecurityAnnex;
Constant InterrogRoomReal SecurityAnnex;

Object poisonpen "pen"
  with name 'pen',
  has transparent;
Object pennib "nib"
  with name 'nib';
Object penstain "stain"
  with name 'stain';

Object storetable "table";
Constant officedesk storetable;
Constant officebookcase storetable;
Constant interrealdesk storetable;
Constant interrealchair storetable;

Object q5_da1
  class Question;

Constant q5_da2 q5_da1;
Constant q5_da3 q5_da1;

[ DebugBlip; "No blips in this version. [DEBUG]"; ];

#endif; ! SKIP_SCENE_5;

#ifdef SKIP_SCENE_6;

Object sc_6
  class Scene,
  with
	number 6,
	begin_scene [ rock;
		rock = 0;
		move activeplayer to FakeFrontier;
	];

Object FakeFrontier "Fake Frontier"
  with
	description "Sixth room.";

#endif; ! SKIP_SCENE_6;

