
[ LockedInLab;
	labdoorguards.shutdown();
		
	! you can steal up to 4 free turns in the lab before this happens.
];

Object insidelabvoice
  with
	number 0,
	startup [;
		if (self.number)
			"^   . []";
		StartDaemon(self);
	],
	daemon [ ix;
	
		if (labconsole has general) {
			! check for shutdowns
			ix = 0;
			if (cabinetcontents has general)
				ix = 6;
			else if (cabinetplate notin labcabinet)
				ix = 2;
			else if (cabinetplate has general)
				ix = 4;
			if (ix) {
				give labconsole ~general;
				labconsole.number = -1;
				print "^   . ";
				labconreadout.set_active(ix);
			}
		}
		
		if (labconsole has general) {
			! ok, it's really working.
			if (labconsole.number >= 0) {
			
				if (self.number < 100) {
					! summon Himself
					self.number = 100;
				}
				
				labconsole.number--;
				if (labconsole.number == 0) {
					! it's time.
					if (gocage has open) {
						labconsole.number = -1;
						new_line;
						labconreadout.set_active(30);
					}
					else {
						OutTheWindow();
						rtrue; ! and deadflag is now set.
					}
				}
				else {
					! still in countdown.
					new_line;
					labconreadout.set_active(25);
				}
			}
		}
        
		self.number++;
		switch (self.number) {
			6:
				print "^   . @<< ?@>>^";
			8:
				print "^@<<   @>>, --  -    . @<<..., - ...@>>^";
			9:
				print "^@<<    . , ?@>>  ,  - : @<<,  .      ,    ,      @>>.^";
			11:
				print "^-  : @<<-,   @>>.^";
			14:
				print "^@<< ,  -  ?@>> --  .     .^";
			18:
				print "^@<<   ,      @>>, --  -.^";
			21:
				print "^@<<,   @>>.^";
			22:
				print "^       .     .^";
			23:
				print "^@<< ,  ", (emphstring) "", "        @>>, --  -.^";
			27:
				print "^  : @<<...  ?@>> @<<  .    ,      @>>.^";
			31:
				print "^@<<, !@>> --  .    . @<<, , @>>, --   .^";
			34:
				print "^@<<,    .    - ,  - ?@>> -,  , : @<<,     @>>.^";
			38:
				print "^     . @<<  !@>> -   .^";
			40:
				print "^     . @<<, @>>, --  -.^";
			41:
				print "^@<< , ?    ,     @>>.^";
			42:
				deadflag = DiedAtHome();
				"^     .    ,    ;        . ,     ,   .^";
			99:
				deadflag = 3;
				"^   . []";
			100: ! skipped, do nothing
			101: 
				print "^@<<   .   - @>>, --   - . -  : @<<   ,  , ?@>>^";
			102:
				print "^@<<׸ , @>>.     ,       . @<< @>>.^";
			103:
				print "^@<<  , @>>, --  -  . @<<   .   @>>.^";
			104:
				print "^ ,   . @<< -- --@>>   ,     ,     ,      .^";
			105:
				print "^@<<   , ,     @>>, --    . @<< .    .        -    .    @>>.^";
			106:
				deadflag = DiedAtHome();
				print_ret "^@<<", (emphstring) "", "@>>, --   ,  - : @<<,   @>>.^^@<<@>>, --    . @<<.  .  @>>.^^,   .   ,  ,   .      .      .";
		}
	];

#ifdef NOT_DEFINED;

Class OrdinaryHeatable
  with
	temperature 0,
	adjust_temp [ envval;
		self.temperature = AdjustTemperature(self.temperature, envval);
	],
	before [;
		Touch:
			switch (self.temperature) {
				1: 
					print_ret "    ", 
						(cGen) self, " .";
				2: 
					"    ", 
						(cGen) self, " .";
				3: 
					" ,   ", 
						(cGen) self, "   .";
				default: 
					rfalse;
			}
		Take:
			switch (self.temperature) {
				2: print_ret (CCNom) noun, "  ", (AEnd2) noun, ".";
				3: print_ret (CCNom) noun, "  ", (AEnd2) noun, ",  ", (GenIt2) noun, "  .";
				default:
			}
	],
	after [;
		Take:
			if (self.temperature == 1)
				print_ret "  ", (AEnd) noun,  " ", (cAcc) noun, "  ,  ", (PronounS) noun,"  ", (V1bEnd) noun, ".";
	];

#endif; ! NOT_DEFINED;

Object nameoffire
  with
	name '' '' '' '' '' '' '';

Class BurnablePaper
  with
	!parse_name [ num wd;
	!	num = 0;
	!	wd = NextWord();
	!	while ((WordInProperty(wd, self, name) ~= 0)
	!		|| (self.smoking == 2 && WordInProperty(wd, nameoffire, name) ~= 0)) {
	!		num++;
	!		wd = NextWord();
	!	} 
	!	return num;
	!],
	invent [;
		if (inventory_stage == 2) {
			if (self.smoking == 2)
				print " ( ", (V2bEnd) self, ")";
			rtrue;
		}
	],
	partinvent [; return self.invent(); ],
	temperature 0, 
	discoloration 0, 
	burnedness 0, 
	smoking 0, ! 0 = nothing, 1 = smoke, 2 = fire, 3 = entirely burnt.
	stage_list 2 4 6 8, 
		! just alight; burning; more than half burnt; nearly burnt; gone
	adjust_temp [ envval    ix printed;
		if (self.smoking >= 3) {
			return;
		}
		else if (self.smoking == 2) {
			self.burnedness++;
			ix = FindStage(self, self.burnedness);
			if (ix >= 4) {
				self.ash_and_gone();
				return;
			}
			if (ix >= 1 && (self.&stage_list)-->(ix-1) == self.burnedness) {
				switch (ix) {
					1: print "^", (CCNom) self, "  ", (V2bEnd) self,".^";
					2: print "^ ", (cGen) self, "  .^";
					3: print "^", (CCNom) self, "   ", (VPEnd) self, ".^";
				}
			}
		}
		else {
			printed = 0;
			self.temperature = AdjustTemperature(self.temperature, envval);
			
			if (anywherein(self, labtable) && papermess.burnedness >= 8
				&& self.smoking < 2) {
				self.temperature = 3;
				self.smoking = 1;
			}
			
			if (self.temperature == 3) {
				if (self.smoking == 0) {
					self.smoking = 1;
					print "^ ", (cGen) self, "   .^";
					printed = 1;
				}
				else {
					self.smoking = 2;
					print "^ ", (cGen) self, "  .^";
					printed = 1;
				}
			}
			else {
				if (self.smoking) {
					self.smoking = 0;
					print "^ ", (cGen) self, "   ,  ", (PronounS) self;
					switch (self.discoloration) {
						0: print "  () []";
						1: print " ", (VPEnd) self;
						2, 3: print " ", (VPEnd) self;
						default: print " ", (VPEnd) self," - ";
					}
					print "  .^";
					printed = 1;
				}
			}
			
			if (self.temperature >= 2) {
				self.discoloration++;
				if (printed == 0) {
					switch (self.discoloration) {
						1: print "^", (CCNom) self, " ", (V1bEnd) self, "  .^";
						2: print "^", (CCNom) self, " ", (V1bEnd) self, ".^";
						3: print "^", (CCNom) self, " ", (V1bEnd) self, ".^";
						4: print "^", (CCNom) self, "  ", (AEnd) self, "  ", (AEnd) self, ".^";
					}
				}
			}
		}
	],
	print_discoloration [ contentstr ix;
		if (self.smoking >= 3) {
			print (CCNom) self, "  ,  ,     . []^";
			rtrue;
		}
		if (self.smoking >= 2) {
			ix = FindStage(self, self.burnedness);
			switch (ix) {
				0: 
					print (string) contentstr, "   .";
				1: 
					print (string) contentstr, "  .";
				2: 
					print (string) contentstr, "  - ,      .";
				3: 
					print "     .";
				default: 
					print " --   . []";
			}
			new_line;
			rtrue;
		}
		print (string) contentstr;
		switch (self.discoloration) {
			0: ! do nothing
			1: print "   .";
			2: print "    .";
			3: print "     .";
			default: print "   -  ,        .";
		}
		if (self.smoking) {
			if (self.discoloration == 0)
				print "  ";
			else
				print "  ", (cGen) self;
			print "  .";
			
		}
		new_line;
		rtrue;
	],
	ash_and_gone [  obj dest;
		new_line;
		if (self in player) {
			print "     ", (cGen) self, ".     ", (GenIt) self, "  ", (PronounS) self;
			move self to parent(player);
		}
		else {
			print (CCNom) self;
		}
		dest = parent(self);
		if (dest == labtable && papermess.burnedness) {
			print " ", (V1bEnd) self, "   .^";
		}
		else {
			print "  ", (V1aEnd) self,",          .^";
		}
		self.smoking = 3;
		self.temperature = 0;
		self.discoloration = 99;
		if (dest == labtable && papermess.burnedness) {
			! was on burning table;
		}
		else if (dest ~= 0) {
			obj = PaperAsh.create();
			if (obj) {
				move obj to dest;
			}
		}
		remove self;
	],
	before [;
		Smell:
			if (self.smoking)
				"  .";
		TouchTo:
			if (IsOnFire(second)) {
				if (self.smoking >= 2)
					print_ret (CCNom) self, "  ", (V2bEnd) self, ".";
				self.smoking = 2;
				print_ret "   ", (cGen) self, "  , ", (PronounS) self, "  ", (V1bEnd) self, ".";
			}
		TouchFrom:
			if (IsOnFire(noun))
				<<TouchTo self noun>>;
		Receive:
			if (noun ofclass BurnablePaper && IsOnFire(noun))
				<<TouchTo self noun>>;
			if (noun ofclass BurnablePaper && IsOnFire(self))
				<<TouchTo noun self>>;
		#ifdef ZDEBUG;
		Rub:
			self.smoking = 2;
			print_ret (CCNom) self, " ", (V1bEnd) self, ". []";
		#endif;
	];

! find the lowest value (ix+1) for which (val >= stagelist-->ix). Thats 0..4.
[ FindStage obj val    ix ptr;
	if (~~(obj ofclass BurnablePaper)) {
		print_ret "FindStage    ", (name) obj, " --    . []";
	}
	if (obj.#stage_list ~= 8)
		print_ret "FindStage ,   ", (name) obj, "  stage list. []";
	ptr = obj.&stage_list;
	for (ix = 0 : ix < 5 : ix++) {
		if (val < ptr-->ix)
			return ix;
	}
	return 5;
];

[ IsOnFire obj;
	if (obj ofclass BurnablePaper && obj.smoking >= 2)
		rtrue;
	if (obj == papermess && papermess.burnedness)
		rtrue;
	if (obj == labtable && papermess.burnedness >= 8)
		rtrue;
	rfalse;
];

Class PaperAsh(6)
  with
	name '' '' '' '' '',
	short_name "",
	article "",
	plural " ",
	description [;
		if (verb_word == '')
			"   .";
		" ,   - .";
	],
	before [;
		Touch:
			"   .";
		Smell:
			" -   .";
		Blow, Rub:
			PaperAsh.destroy(self);
			"  .";
	],
	after [ obj objnext ix;
		Take:
			ix = 0;
			obj = child(player);
			while (obj) {
				if (obj ofclass PaperAsh && obj ~= self) {
					ix++;
					objnext = sibling(obj);
					remove obj;
					PaperAsh.destroy(obj);
					obj = objnext;
				}
				else {
					obj = sibling(obj);
				}
			}
			if (ix)
				"    .";
			else
				"     .";
	];
	
[ AdjustTemperature curtemp envtemp;
	! allow for -1, meaning 0
	if (envtemp < 0)
		envtemp = 0;
		
	if (curtemp == envtemp)
		return curtemp;
	if (curtemp < envtemp)
		return curtemp+1;
	else
		return curtemp-1;
];

[ FindEnvTemp obj   ix;
	if (anywherein(obj, hotplate)) {
		ix = hotplate.heat_source;
		if (ix < 0)
			ix = 0;
		switch (papermess.burnedness) {
			0: ! do nothing
			1 to 4: if (ix<2) ix = 2;
			default: if (ix<3) ix = 3;
		}
		return ix;
	}
	if (anywherein(obj, labtable)) {
		switch (papermess.burnedness) {
			0: return 0;
			1 to 4: return 2;
			default: return 3;
		}
	}
	return 0;
];

Object Laboratory "",
  with
	initial [;
		if (self hasnt general) {
			give self general;
			insidelabvoice.startup();
			hotplate.startup();
		}
	],
	description [ skipmat;
		print "  ,    .      ";
		if (self hasnt visited)
			print " --   , ,    --";
		else
			print ",";
		print "     ,  ,      .    ";
		if (labdoor has open)
			print " ";
		else
			print " ";
		print ";       ,    .^";
		
		print "^  ,   ,    ,       .     .    ,         ;        .^";
		
		switch (papermess.burnedness) {
			0:
				print "^   ,   ,       .        . ";
			1 to 4:
				print "^   ,   ,       .       .        . ";
			5 to 7:
				print "^   ,   ,     .    ,     .^^";
			8 to 11:
				print "^   ,   ,     .    ,     .^^";
			12 to 14:
				print "^   ,   ,     .    ,     .^^";
			15 to 17:
				print "^  ,   ,  .  ,       .^^";
			default:
				print "^  ,   ,  ;    .  ,       .^^";
		}
		
		print "    ,     ,    - .";
		skipmat = 0;
		if (child(labmat) == testblock && sibling(testblock) == nothing) {
			skipmat = 1;
			print "     .";
		}
		new_line;
		
		if (child(labmat) && skipmat == 0) {
			new_line;
			<Search labmat>;
		}
		
		if (player notin gocage && child(gocage)) {
			new_line;
			<Search gocage>;
		}
		
		rtrue;
	],
	out_to labdoorin,
	e_to labdoorin,
	in_to [; <<Enter gocage>>; ],
	cant_go "      ,    .",
  has ~general; ! general, the first time you enter.

Object -> skankbarrier " []"
  with
	cage_barrier [ obj;
		if (obj == 0 or gocage)
			rfalse; ! can always touch borders 
		if ((obj == goplatform or goplatformpattern) || anywherein(obj, gocage)) {
			! obj is inside
			if (gocage hasnt open && player notin gocage)
				print_ret "    ", (cGen) obj, "  ,    .";
		}
		else {
			! obj is outside
			if (player in gocage)
				print_ret "    ", (cGen) obj, "  .";
		}
		rfalse;
	],
	react_before [;
		Examine, Search, Listen:
			rfalse;
		ShootAttack:
			rfalse; ! can shoot through cage
		Insert, PutOn, BaseTouchTo, AttackWith, WriteWith:
			if (action == ##AttackWith) {
				if (second ofclass PulseGun) {
					rfalse; ! can shoot through cage
				}
			}
			if (action == ##Insert or ##PutOn) {
				if (second == goplatform) {
					rfalse; ! can put things on platform
				}
			}
			if (noun && self.cage_barrier(noun))
				rtrue;
			if (second && self.cage_barrier(second))
				rtrue;
		default:
			if (action == ##Enter) {
				if (noun == goplatform) {
					rfalse; ! can get on platform
				}
			}
			if (noun && self.cage_barrier(noun))
				rtrue;
	],
  has scenery;

Object -> goplatform "/"
  with
	name '' '' '' '' '',
	description [;
		print "         ; -         .     . -   ,   .    -  ;        ,      ,  .^";
		if (1) {
			new_line;
			<Search gocage>;
		}
		rtrue;
	],
	before [;
		Examine:
			rfalse;
		Search:
			<<Search gocage>>;
		Receive:
			<<Insert noun gocage>>;
		Enter:
			<<Enter gocage>>;
		GetOff:
			if (player in gocage)
				<<Exit>>;
		Touch:
			L__M(##Touch, 2, noun);
			rtrue;
	],
  has scenery transparent female;

Object -> -> goplatformpattern "/ /"
  with
	name '' '' '' '',
	before [;
		"   .";
	],
  has scenery male;

Object -> gocage "/"
  with
	name '' '' '' '' '' '' '' ''
		'ring',
	description [;
		print "      .      .    ,       --      ,      .    ,     ,";
		if (self hasnt open)
			print "  .";
		else
			print " .";
		new_line;
		if (child(self)) {
			new_line;
			<Search self>;
		}
		rtrue;
	],
	vehicle_name " (  )",
	vehicle_status_name ",  ",
	react_before [;
		Exit:
			if (player in self) {
				if (self hasnt open)
					"     ,    .";
				move player to parent(self);
				if (keep_silent == 0)
					print "   .^";
				rtrue;
			}
	],
	before [;
		Search:
			if (child(self) == nothing)
				"   .";
			if (player in self && children(self) == 1) {
				"   ,   .";
			}
			print " ";
			if (player in self)
				print "   ";
            else
                print " ";
            if (children(self) > 1)
                print "";
            else
                print "";
            print " ";
			WriteListFrom(child(self),
				! ISARE_BIT + TERSE_BIT + ENGLISH_BIT + PARTINV_BIT + CONCEAL_BIT);
				TERSE_BIT + ENGLISH_BIT + PARTINV_BIT + CONCEAL_BIT);
			".";
		Enter:
			if (self hasnt open)
				"     ,   .";
			rfalse;
	],
	after [;
		Enter:
			"        .";
		Open:
			"       ;  .";
		Close:
			if (player in self)
				"    ,    .";
			else
				"      .";
	],
  has scenery enterable container openable ~open transparent female;

Object -> labconsole "/"
  with
	name '' '',
	description [;
		print " ,  ,   , ,         .     ,     ,    --      .       .";
		print "^^";
		if (self has general) {
			print "   ,  . ";
		}
		print "  : ";
		labconreadout.answer_general();
		new_line;
		rtrue;
	],
	number -1, ! the fuse counter
	react_before [;
		Listen:
			if (noun == 0)
				<<Listen self>>;
	],
	before [;
		Examine:
			if (verb_word == 'read')
				<<Examine labconlabels>>;
		Listen:
			if (self hasnt general)
				rfalse;
			if (self.number < 0)
				"-   .";
			"-   .";
	],
  has scenery transparent female; ! general means turned on.

Object -> -> labconlabels "/"
  with
	name '' '' '' '',
	description "      : @<< @>>.     @<<@>>,   -- @<<@>>.",
	before [;
		Push:
			"  ,    .";
	],
  has scenery pluralname;

Object -> -> labconreadybutton "/ /"
  with
	name '' '' '' '',
	description "    @<<@>>.",
	before [ ix;
		SwitchOn, SwitchOff, Turn: <<Push self>>;
		Push:
			if (labconsole hasnt general) {
				if (cabinetcontents has general)
					ix = 5;
				else if (cabinetplate notin labcabinet)
					ix = 1;
				else if (cabinetplate has general)
					ix = 3;
				else {
					give labconsole general;
					labconsole.number = -1;
					ix = 20;
					print "   ,       . ";
				}
				labconreadout.set_active(ix);
			}
			else {
				if (labconsole.number >= 0)
					<<Push labcongobutton>>;
				! stay ready
				labconreadout.set_active(20);
			}
			rtrue;
	],
  has scenery female;

Object -> -> labcongobutton "/ /"
  with
	name '' '' '' '',
	description "    @<<@>>.",
	before [;
		SwitchOn, SwitchOff, Turn: <<Push self>>;
		Push:
			if (labconsole hasnt general) {
				labconreadout.set_active(22);
				rtrue;
			}
			if (labconsole.number < 0) {
				! start it up.
				labconsole.number = 6;
				"       .";
			}
			else {
				! go back to readiness
				labconsole.number = -1;
				print "   . ";
				labconreadout.set_active(21);
			}
			rtrue;
	],
  has scenery female;

Object -> -> labconoval "/ /"
  with
	name '' '' '' '' '',
	description "    ,     ,      .    : @<< @>>.",
	before [;
		Push, Rub, Attack:
			<<Touch self>>;
		TouchFrom:
			if (noun == lockpick)
				rfalse;
			<<Touch self>>;
		Touch:
			if (labconsole hasnt general)
				"  .";
			if (self hasnt general) {
				give self general;
				"     ,      --       ,   ,   .     ...    ,   .";
			}
			else {
				"     .";
			}
	],
  has scenery male; ! general means not on the mat.

Object -> -> labcondisplay "/"
  with
	name '' '' '' '' '' '',
	description [;
		if (labconsole hasnt general)
			" .";
		"    .        .    ,    .";
	],
	before [;
		Search: <<Examine self>>;
	],
  has scenery male;

Constant CannotInit "@<< : ";
Constant UnexFailure "@<< : ";

Object -> -> labconreadout "/ "
  with
	name '' '' '',
	description [;
		if (player in gocage)
			print "   ,            .  : ";
		else
			print " : ";
		self.answer_general();
		new_line;
		rtrue;
	],
	number 0, ! output code.
	set_active [ val;
		if (val == self.number && val ~= 25) {
			print "       ";
		}
		else {
			print "       ";
		}
		self.number = val;
		self.answer_general();
		new_line;
		rtrue;
	],
	answer_general [;
		! codes < 20 are for when system is off; >= 20 for when it's on.
		switch (self.number) {
			0: print "@<<  @>>.";
			1: print (string) CannotInit, " NZ73  @>>.";
			2: print (string) UnexFailure, " NZ73 @>>.";
			3: print (string) CannotInit, " NZ73    @>>.";
			4: print (string) UnexFailure, " NZ73  @>>.";
			5: print (string) CannotInit, "     @>>.";
			6: print (string) UnexFailure, "   @>>.";
			20: print "@<< @>>.";
			21: print "@<< @>>.";
			22: print "@<<  @>>.";
			25: 
				print "@<< ,   ", labconsole.number, "";
				if (gocage has open)
					print ". :     ";
				print "@>>.";
			30: print "@<< :     @>>.";
			default: print "@<<@>>. []";
		}
		rtrue;
	],
	before [;
		Search: <<Examine self>>;
	],
  has scenery female;

Object -> labcables "/"
  with
	name '' '' '',
	description "    .      ,  --     ,   ,  ,      ,   .",
	before [;
		Take, Push, Pull:
			"   ,       .";
		Attack:
			"     ,     .";
	],
  has scenery pluralname;

Object -> labcabinet "/"
  with
	name '' '' '',
	description [;
		print "     ,       .";
		if (self hasnt open) {
			"  ,  ,    ,         .   .";
		}
		print "   . ";
		<Search self>;
		rtrue;
	],
	shortout [;
		if (self has open) {
			cabinetcontents.shortout();
			rtrue;
		}
	],
	before [;
		Search:
			if (self hasnt open)
				" .";
			print "       .";
			if (cabinetplate notin self)
				print "      ,         .";
			else
				print "     .";
			new_line;
			rtrue;
		Empty, EmptyT:
			if (cabinetplate in self)
				<<Take cabinetplate>>;
			",    ,  .";
		Receive:
			if (cabinetplate in self)
				"     .";
			if (noun ~= cabinetplate)
				print_ret (CCNom) noun, "  ", (V2bEnd) noun, "   .";
		Push, Pull, Take:
			"   .";
	],
	after [;
		Open:
			print "  . ";
			<<Search self>>;
		Receive:
			"  ", (cAcc) noun, "     .";
		LetGo:
			if (noun ~= cabinetplate)
				print_ret "   ", (cNom) noun, "? []";
			print "  ", (cAcc) noun, "  .^";
			rtrue;
	],
  has scenery container openable ~open male;

Object -> -> cabinetcontents "/ /"
  with
	name '' '' '' '' '' '',
	shortout [;
		give self general;
		print_ret "    .         .";
	],
	before [;
		Examine, Search:
			<<Search labcabinet>>;
		Receive:
			<<Insert noun labcabinet>>;
		Empty:
			<<Empty labcabinet>>;
	],
  has scenery pluralname; ! general means it's fried

Object -> labmatring "/ /"
  with
	name '' '' '' '' '',
	description "        .",
	before [;
		Enter: <<Enter labmat>>;
		Receive: <<PutOn noun labmat>>;
		Search: <<Search labmat>>;
	],
  has scenery female;

Object -> labmat "/ /"
  with
	name '' '' '' '' '',
	description [;
		print "     ,     .      .^";
		if (child(self)) {
			new_line;
			<Search self>;
		}
		rtrue;
	],
	supporter_describe [; rtrue; ],
	before [;
		Search:
			if (child(self) == nothing)
				print_ret " ", (cPre) self, "  .";
			print " ", (cPre) self;
			WriteListFrom(child(self),
				ISARE_BIT + TERSE_BIT + ENGLISH_BIT + PARTINV_BIT);
			".";
		Enter:
			" .";
		Receive:
			if (receive_action == ##Insert)
				<<PutOn noun self>>;
		Touch, Push, Attack:
			"  .";
		Take:
			", ,   .";
	],
  has scenery supporter male;

Object -> -> testblock "/ /"
  with
	name '' '' '' '',
	description "  ,   .",
	before [;
		Touch:
			"   .";
		Attack:
			"       .";
	],
  has male;

Object -> labtable "/ /"
  with
	name '' '' '' '',
	description [;
		
		print "     ";
		switch (papermess.burnedness) {
			0:
				print ".       -- , ,  --    ,  -   .^^      .";
			1 to 4:
				print ".       -- , ,  --    ,  -   .       .^^      .";
			5 to 7:
				print ".            -- , , , --     .";
			8 to 11:
				print ".            -- , , , --     .";
			12 to 14:
				print ".           ,     .";
			15 to 17:
				print ",   .  ,       .";
			default:
				print ";   ,     .  ,       .";
		}
		
		
		if (self.just_a_pile()) {
			new_line;
		}
		else {
			print "    ";
            if (children(self) > 1)
                print "";
            else
                print "";
            print " ";
			WriteListFrom(child(self),
				CONCEAL_BIT + TERSE_BIT + ENGLISH_BIT + RECURSE_BIT + PARTINV_BIT);
			print ".^";
		}
		rtrue;
	],
	just_a_pile [ ix;
		objectloop (ix in self) {
			if (ix == papermess)
				continue;
			if (ix == cabinetplate && cabinetplate has scenery)
				continue;
			rfalse;
		}
		rtrue;
	],
	supporter_describe [;
		! only called if there's something non-scenery to describe.
		switch (papermess.burnedness) {
			0:
				print "^ ,  ", (cGen) papermess, "     ";
			1 to 4:
				print "^  ,   , ";
			default:
				print "^  ,  , ";
		}
        !if (children(self) > 1)
        !    print "";
        !else
        !    print "";
        !print " ";
		WriteListFrom(child(self),
			ENGLISH_BIT + RECURSE_BIT + PARTINV_BIT
			+ TERSE_BIT + CONCEAL_BIT);
		".";
	],
	react_before [;
		Examine, Search, Listen:
			rfalse;
		default:
			if (noun) {
				if ((noun == hotplate or hotplateswitch)
					|| anywherein(noun, self) || anywherein(noun, hotplate)) {
					if (noun == papermess)
						rfalse; ! the papermess has its own handlers.
					if (self.heat_barrier(noun)) rtrue;
				}
			}
			rfalse;
	],
	before [;
		Search:
			if (papermess hasnt general) {
				if (papermess.burnedness < 8)
					<<Search papermess>>;
				print "    ,   .      ,  ";
			}
			else {
				print "    , ";
			}
			print "       .";
			switch (papermess.burnedness) {
				0: ! nothing
				1 to 4: print "    .";
				5 to 7: print "   .";
				8 to 11: print "     .";
				default: print "   .";
			}
			if (self.just_a_pile()) {
				new_line;
			}
			else {
				print "    ";
                if (children(self) > 1)
                    print "";
                else
                    print "";
                print " ";
				WriteListFrom(child(self),
					CONCEAL_BIT + TERSE_BIT + ENGLISH_BIT + RECURSE_BIT + PARTINV_BIT);
				print ".^";
			}
			rtrue;
		Push, Pull:
			"   .";
		#ifdef ZDEBUG;
		Rub:
			papermess.startup();
			" . []";
		#endif;
		LookUnder:
			if (self.heat_barrier()) rtrue;
			"     .";
		LetGo:
			if (self.heat_barrier(noun)) rtrue;
			rfalse;
		Touch:
			if (self.heat_barrier()) rtrue;
			rfalse;
	],
	after [;
		LetGo:
			if (papermess.burnedness)
				print_ret "  ", (cAcc) noun, "  .";
		Receive:
			if (papermess.burnedness >= 8) {
				print_ret "  ", (cAcc) noun, "     .";
			}
	],
	heat_barrier [ obj;
		if (papermess.burnedness >= 8) {
			if (obj)
				print "     ", (cGen) obj, "  - ,   .";
			else
				print "       -,   .";
			"   .";
		}
		rfalse;
	],
  has scenery supporter male;

Object -> -> papermess "// "
  with
	name '' '' '',
	!parse_name [ num wd;
	!	self.parse_used_scrapword = 0;
	!	num = 0;
	!	wd = NextWord();
	!	while ((WordInProperty(wd, self, name) ~= 0)
	!		|| (self.burnedness && WordInProperty(wd, nameoffire, name) ~= 0)
	!		|| (self has general && wd == 'useless')
	!		|| (parent(uselesspaper) == 0 && wd == 'scrap')) {
	!		if (wd == 'scrap')
	!			self.parse_used_scrapword = 1;
	!		num++;
	!		wd = NextWord();
	!	}
	!	if (self.parse_used_scrapword) {
	!		print "(", (cNom) self, ")^";
	!		self.parse_used_scrapword = 0;
	!	}
	!	return num;
	!],
	parse_used_scrapword 0,
	short_name [;
		if (self hasnt general)
			print " ";
		else
			print "  ";
		rtrue;
	],
	description [;
		if (self.burnedness >= 8) {
			"     ,    .";
		}
		if (self hasnt general) {
			<<Search self>>;
		}
		print "      ,  ,    --    , --             .";
		switch (self.burnedness) {
			0: ! do nothing
			1, 2: print "     .";
			3, 4: print "   .";
			default: print "    .";
		}
		new_line;
		rtrue;
	],
	before [;
		Search:
			if (self.burnedness >= 8) {
				"     ,    .        .";
			}
			if (player in gocage) {
				"    ,   .";
			}
			if (self hasnt general) {
				if (self.burnedness == 0) 
					print " ,     ,     .";
				else
					print "    ,          .";
				print "         , ,   .          ,  .^";
				give self general;
				if (self.burnedness) {
					move usefulstack to parent(labtable);
				}
				else {
					move usefulstack to labtable;
				}
				if (cabinetplate has scenery) {
					give cabinetplate ~scenery;
					print "^    ,         .";
					if (self.burnedness) {
						move cabinetplate to player;
						print "      .";
					}
					new_line;
				}
				rtrue;
			}
			else {
				"    ,    - .";
			}
		LookUnder:
			if (self.burnedness >= 8)
				<<Search self>>;
			if (self.burnedness)
				print "  ,   . ";
			if (cabinetplate has scenery) {
				give cabinetplate ~scenery;
				"       .";
			}
			else {
				"   ,    .";
			}
		Take:
			if (self.burnedness >= 8)
				<<Search self>>;
			if (parent(uselesspaper) == 0) {
				move uselesspaper to player;
				PronounNotice(uselesspaper);
				if (self.burnedness)
					print "  , ";
				else
					print "";
				if (self hasnt general)
					"     .    ,    - .";
				else
					"         ,   .";
			}
			else {
				if (self hasnt general)
					"    .    ,    - .";
				else
					"    ,   ,    ,    ,    .";
			}
		Receive:
			<<PutOn noun labtable>>;
		TouchFrom:
			if (IsOnFire(noun)) {
				if (self.burnedness)
					rfalse;
				self.startup();
				print_ret "  ", (cAcc) noun, "    ,   .    .";
			}
		TouchTo:
			if (IsOnFire(second))
				<<BaseTouchTo second self>>;
	],
	burnedness 0, ! 1 or more means burning.
	startup [;
		! start the fire
		if (self.burnedness)
			return;
		self.burnedness = 1;
		! move tableash to labtable;
	],
	daemon [ ix;
		! subdaemon of fire stuff. This is called before other items.
		
		if (self.burnedness == 0) {
			! check for fires on table
			ix = 0;
			if (uselesspaper in labtable && uselesspaper.smoking >= 2)
				ix = uselesspaper;
			if (usefulstack in labtable && usefulstack.smoking >= 2)
				ix = usefulstack;
			if (ix) {
				self.startup();
				print "^  ,   ,    ", (cGen) ix, ".^"; 
			}
		}
		
		if (self.burnedness == 0)
			return;
			
		self.burnedness++;
		switch (self.burnedness) {
			3:
				print "^     .^";
			5:
				print "^   .^";
			8:
				print "^       .      .^";
			12:
				print "^       ,     .^";
			14:
				print "^ .^";
			18:
				print "^     .       .^";
			22:
				print "^    .^";
			24:
				print "^   .     ; ,  ,    .^";
			28:
				print "^ .^";
			default:
				if (self.burnedness >= 30) {
					if (self.burnedness % 4 == 0)
						print "^ .^";
				}
		}
		
	],
  has scenery pluralname; ! general means it's been sorted.

Object -> -> cabinetplate "/ /"
  with
	name '' '' '' '',
	description "   ,    --        ,  .      ,      .",
	shortout [;
		give self general;
		"    .      .";
	],
	before [;
		Take, Push, Push, Search, Examine:
			if (self has scenery) {
				give self ~scenery;
				print "( ", (cAcc) self, "  )^";
				rfalse;
			}
	],
  has scenery ~general female; ! general means it's fried. 

Object -> hotplate "/ /"
  with
	name '' '' '' '' '' '',
	description [;
		print "׸ ,     ,   , .  ,   .       .    ,";
		if (child(self))
			print "   ", (V2aEnd) child(self), " ", (cNom) child(self);
		else
			print "    ";
		print ".  ";
		if (self hasnt general)
			print "   ";
		else
			print "  ,   ";
		".";
	],
	react_before [;
		Examine:
			rfalse;
		Touch:
			if (noun in self) {
				if (noun provides adjust_temp)
					rfalse;
				switch (self.temperature) {
					1: 
						print_ret "  ,   ", 
							(cGen) noun, ".";
					2: 
						"  ,   ", 
							(cGen) noun, ".";
					3: 
						"   ,   ", 
							(cGen) noun, ".";
					default: 
						rfalse;
				}
			}
			rfalse;
	],
	before [;
		Search:
			if (child(self))
				print_ret "    ", (cNom) child(self), ".";
			else
				print_ret "    .";
		Take, Push, Pull:
			"   .";
		Touch:
			switch (self.heat_source) {
				1: "  ,   .";
				2: "  ,   .";
				3: "   ,   .";
				default: "    .";
			}
		SwitchOn, SwitchOff:
			<<(action) hotplateswitch>>;
		Receive:
			if (labtable.heat_barrier(self)) rtrue;
			if (child(self))
				print_ret "    ", (V2aEnd) child(self), " ", (cNom) child(self), ".";
			else
				rfalse;
		LetGo:
			if (labtable.heat_barrier(noun)) rtrue;
			if (noun provides adjust_temp)
				rfalse;
			switch (self.temperature) {
				2: print_ret (CCNom) noun, "  ", (AEnd2) noun, ".";
				3: print_ret (CCNom) noun, "  ", (AEnd2) noun, ",  ", (GenIt2) noun, "  .";
				default:
			}
	],
	after [;
		LetGo:
			if (noun provides adjust_temp)
				rfalse;
			if (self.temperature == 1)
				print_ret "  ", (AEnd) noun,  " ", (cAcc) noun, "  ,  ", (PronounS) noun,"  ", (V1bEnd) noun, ".";
	],
	startup [;
		StartDaemon(self);
		self.heat_source = -1;
	],
	heat_source 0, ! temperature of heating element
	temperature 0, ! temperature of contents, if applicable
	daemon_priority -30, ! lower than insidevoice
	daemon [ ix obj;
		! this handles all the heat and fire
		! temperatures are 0=cool, 1=warm, 2=hot, 3=damn hot
		! heat_source can also be -1, meaning cool but bored
		
		! the alcove
		if (self has general) {
			if (self.heat_source < 3)
				self.heat_source++;
		}
		else {
			if (self.heat_source >= 0)
				self.heat_source--;
		}
		
		! generic contents
		obj = child(self);
		if (obj == 0) {
			self.temperature = 0;
		}
		else if (obj provides adjust_temp) {
			! do nothing; it will be handled separately
		}
		else {
			self.temperature = AdjustTemperature(self.temperature, self.heat_source);
		}
		
		! adjust_temp properties are called every round.
		
		papermess.daemon();
		
		ix = FindEnvTemp(uselesspaper);
		uselesspaper.adjust_temp(ix);
		
		ix = FindEnvTemp(usefulstack);
		usefulstack.adjust_temp(ix);
		
		ix = FindEnvTemp(hotpot);
		hotpot.adjust_temp(ix);
	],
  has scenery open container neuter; ! general means on, of course

Object -> -> hotpot "/ /"
  with
	name '' '' '' '' '',
	description [;
		print "        ;   .    . ";
		<<Search self>>;
	],
	temperature 0,
	adjust_temp [ envval oldval;
		oldval = self.temperature;
		self.temperature = AdjustTemperature(self.temperature, envval);
		if (papermess.burnedness == 0) {
			! skip the smell if the table is on fire
			switch (self.temperature) {
				0, 1:
					if (oldval > 1)
						print "^  .^";
				2:
					if (oldval < 2)
						print "^ - .^";
				3:
					if (oldval < 3)
						print "^    ,     .^";
			}
		}
	],
	before [;
		Receive:
			print_ret (CCNom) noun, "    .";
		Search:
			" ,       ,  .";
		Open:
			", ,  .";
		Empty, EmptyT:
			"     .";
		Smell:
			<<Smell hotpotcrust>>;
		Touch:
			switch (self.temperature) {
				0: "    .";
				1: "   .";
				2: "   .";
				3: "  ,   .";
			}
	],
	after [;
		Take:
			switch (self.temperature) {
				2: " ,      .  ,  .";
				3: " ,       .  ,   .";
			}
	],
  has transparent male;

Object -> -> -> hotpotcrust "/ /"
  with
	name '' '' '' '' '' '',
	description "        -  .",
	before [;
		Examine:
			rfalse;
		Smell:
			switch (hotpot.temperature) {
				0, 1: "  .";
				2: "     .";
				3: "     -- , ,     .";
			}
		default:
			"       .";
	],
  has scenery neuter;

Object -> hotplateswitch "/ /"
  with
	name '' '' '' '',
	!parse_name [ num wd val1 val2;
	!	if (hotplate has general) {
	!		val1 = 'red';
	!		val2 = 'glowing';
	!	}
	!	else {
	!		val1 = 'black';
	!		val2 = 'black';
	!	}
	!	num = 0;
	!	wd = NextWord();
	!	while ((WordInProperty(wd, self, name) ~= 0)
	!		|| wd == val1 or val2) {
	!		num++;
	!		wd = NextWord();
	!	} 
	!	return num;
	!],
	short_name [;
		if (hotplate has general)
			print "  ";
		else
			print "  ";
		rtrue;
	],
	before [;
		SwitchOn:
			if (hotplate has general)
				"   .";
			give hotplate general;
			"   ,    .";
		SwitchOff:
			if (hotplate hasnt general)
				"   .";
			give hotplate ~general;
			"  .";
		Turn, Push:
			if (hotplate has general)
				<<SwitchOff self>>;
			else
				<<SwitchOn self>>;
		Take:
			print_ret "  ", (cDat) hotplate, ".";
	],
  has scenery male;

Object -> scenerymachinery "/  "
  with
	name '' '' '' '' '' '',
	before [;
		default:
			print_ret "      ", (cIns) self, ".";
	],
  has scenery neuter;

Object -> labwalls "/"
  with
	name '' '' '' '' '',
	description [;
		print "      .";
		if (papermess.burnedness >= 18) {
			print "     .    ,  , , ,   .";
		}
		new_line;
		rtrue;
	],
	before [;
		Examine:
			rfalse;
		Search:
			<<Examine self>>;
		default:
			<<(action) whitewalls second>>;
	],
  has pluralname scenery;

Object -> labceiling "///"
  with
	name '' '' '',
	description "  ,         ,  .   ,    .",
    casegen [ beg end csID;
        return ICVowel (csID, beg, end, '', 0);
	],
	before [;
		Examine:
			rfalse;
		default:
			"    .";
	],
  has scenery male;

Object -> labdoorin "/ "
  with
	name '' '' '',
	description [;
		print " - , -  ";
		if (labdoor hasnt open)
			print "  .";
		else
			print " - .";
		"         .";
	],
	door_to OutsideLab, 
	door_dir e_to,
	door_try [;
		if (labdoor hasnt open) {
			PronounNotice(self);
			"  .";
		}
	],
  has door open scenery female;

Object -> labpad
  class ContactPad,
  with
	description " -      .     .",
	shortout [;
		give labdoor locked;
	],
	is_active [ noisy;
		if (noisy == 0) {
			if (labdoor has locked)
				rfalse;
			else
				rtrue;
		}
		else {
			if (labdoor has locked)
				"    .";
			give labdoor locked;
			"- ,   ,    .";
		}
	],
	before [;
		Touch:
			if (labdoor has locked)
				"  .";
			if (labdoor has open) {
				give labdoor ~open;
				"  .";
			}
			else {
				give labdoor open;
				"  .";
			}
	];

Object -> labaccess "/ "
  with
	name '' '',
	description [;
		print " ,  ,    .";
		if (self hasnt open)
			"  .";
		else
			"  ,     .";
	],
	shortout [;
		if (self hasnt open)
			rfalse;
		accesscircuits.shortout();
		rtrue;
	],
	before [;
		Empty, EmptyT:
			if (self hasnt open)
				<<Search self>>;
			else
				<<Take accesscircuits>>;
		Search:
			if (self hasnt open)
				" .";
			else
				"      .";
		Receive:
			if (self hasnt open)
				<<Search self>>;
			else
				"    .";
		Attack, AttackWith:
			if (self hasnt open)
				rfalse;
			<<(action) accesscircuits second>>;
	],
	after [;
		Open:
			"       .";
	],
  has scenery container openable ~open male;

Object -> -> accesscircuits "/ /"
  with
	name '' '',
	description "      .",
	shortout [;
		give labdoor locked;
		print_ret " ", (cGen) self, "   .      .";
	],
	before [;
		Take:
			"   .";
		AttackWith:
			if (second ofclass PulseGun)
				rfalse;
			if (self hasnt general) {
				give labdoor locked;
				give self general;
				print_ret "   ", (cAcc) second, "  ,      .";
			}
			else {
				"   .";
			}
		Attack:
			if (self hasnt general) {
				give labdoor locked;
				give self general;
				"     ,      .";
			}
			else {
				"   .";
			}
	],
  has scenery female; ! general for broken

Object tableash "/"
  with
	name '' '',
	before [;
		Examine:
			rfalse;
		default:
			"   .";
	],
  has scenery male;

Object uselesspaper "/// "
  class BurnablePaper,
  with
	name '' '' '' '' '',
    casegen [ beg end csID;
        return ICVowel (csID, beg, end, '', 0);
	],
	stage_list 1 2 4 5, 
	description [;
		self.print_discoloration("    ,     .");
		rtrue;
	],
	before [ ix;
		Examine:
			if (verb_word == '')
				<<Search self>>;
		Search:
			if (self has general)
				ix = "    .";
			else
				ix = "     ,  844.625   6.283  5306.779.";
			self.print_discoloration(ix);
			rtrue;
	],
	ash_and_gone [;
		self.BurnablePaper::ash_and_gone();
		self.temperature = 0;
		self.smoking = 0;
		self.burnedness = 0;
		self.discoloration = 0;
		give self general;
		remove self;
	],
  has ~general male; ! general means it's not the first scrap you've got.

Object usefulstack "/  "
  class BurnablePaper,
  with
	name '' '' '',
	stage_list 1 3 6 8, 
	description [;
		self.print_discoloration("   ,     ,         ,     .");
	],
	before [;
		Search:
			<<Examine self>>;
	],
  has female;

[ DiedAtHome;
	
	! Endings: basically, you can have torched the lab, or not.
	
	if (papermess.burnedness >= 8) {
		return 4;
	}
	
	return 3;
];

[ OutTheWindow   ix;

	! Endings: seven of them.
	!   jumped to the mat (captured)
	!   jumped to the mat, but burned the lab
	!   just leave (don't take papers)
	!   take papers
	!   burn papers
	!   burn lab, take papers
	!   burn lab and papers
	! Of these, burning just the papers is almost the same as leaving them
	! behind, because there are backups.
	
	deadflag = 3;
	
	print "^@<<", (emphstring) "...", "@>>, --   ,    .^^: @<< @>>, --    .  , @<<", (emphstring) "!", "@>>^";
	
	if (anywherein(player, gocage) == 0) {
		print "^       ,     ,      .     ,      ...^";
		print "^...    .";
		! print "^...    ", (emphstring) "snap", ".";
		ix = children(gocage);
		if (ix) {
			print " ";
            if (ix > 1)
				print "   ";
			else
				print "   ";
			WriteListFrom(child(gocage), TERSE_BIT + ENGLISH_BIT + NOARTICLE_BIT);
			
			print ";   ";
			if (labconoval hasnt general) {
				if (ix > 1)
					print ".     ";
				else
					print ". ", (CCNom) child(gocage) ,"    ", (V1bEnd) child(gocage), "";
				print "  ";
			}
			else {
				! off without you.
			}
			print ".";
		}
		else {
			! nothing transmitted.
		}
		
		print "^^     .  ,   ,  ,  .   ,  ,   .      .      .^";
		return;
	}
	
	! the player is definitely going for a ride.
	deadflag = 5;
	
	print "^     ,     ,      .     ,      ...^";
	
	print "^   ,   ,    .  ,   ,     .     ,     .     ,   ,";
	if (anywherein(usefulstack, gocage)) {
		print "  ";
		if (anywherein(usefulstack, player))
			print "   ,";
		else
			print ",   ,";
	}
	!print ",  the light";
	if (papermess.burnedness) {
		deadflag = 4;
		print "    ,   ";
		if (labconoval hasnt general)
			print "  ";
		else
			print ",   ";
	} else { ! y4n
        print "   ";
    }
	print ".^";
	
	if (labconoval hasnt general) {
		print "^      .   ,     ,    .           .^";
	}
	else {
		deadflag = 4;
		print "^  .      .^";
	}
];

